﻿using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using PhoneStore.Models;
using PhoneStore.Repositories.Interfaces;

namespace PhoneStore.Repositories
{
    public class BrandRepository : IBrandRepository
    {
        private readonly MobileContext _db;

        public BrandRepository(MobileContext db)
        {
            _db = db;
        }

        public void Create(Brand entity)
        {
            _db.Brands.Add(entity);
            _db.SaveChanges();
        }

        public async Task CreateAsync(Brand brand)
        {
            await _db.Brands.AddAsync(brand);
            await _db.SaveChangesAsync();
        }

        public IEnumerable<Brand> GetAll()
            => _db.Brands;

        public void Update(Brand entity)
        {
            _db.Brands.Update(entity);
            _db.SaveChanges();
        }

        public Brand GetById(int id)
        {
            return _db.Brands.FirstOrDefault(b => b.Id == id);
        }

        public void Delete(int id)
        {
            var brand = _db.Brands.FirstOrDefault(b => b.Id == id);
            _db.Brands.Remove(brand);
            _db.SaveChanges();
        }
    }
}