﻿using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using PhoneStore.Mappers;
using PhoneStore.Models;
using PhoneStore.Repositories.Interfaces;
using PhoneStore.Services.Interfaces;
using PhoneStore.ViewModels;

namespace PhoneStore.Services
{
    public class BrandService : IBrandService
    {
        private readonly IBrandRepository _brandRepository;

        public BrandService(IBrandRepository brandRepository)
        {
            _brandRepository = brandRepository;
        }
        public async Task CreateAsync(Brand entity) 
            => await _brandRepository.CreateAsync(entity);

        public void Delete(int id)
            => _brandRepository.Delete(id);
        
        public IEnumerable<BrandViewModel> GetAll()
            => _brandRepository.GetAll().Select(x => x.MapToBrandViewModel());

        public void Create(Brand entity)
            => _brandRepository.Create(entity);
    }
}